// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rc_common_msgs:msg/ReturnCodeConstants.idl
// generated code does not contain a copyright notice
#include "rc_common_msgs/msg/detail/return_code_constants__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


bool
rc_common_msgs__msg__ReturnCodeConstants__init(rc_common_msgs__msg__ReturnCodeConstants * msg)
{
  if (!msg) {
    return false;
  }
  // structure_needs_at_least_one_member
  return true;
}

void
rc_common_msgs__msg__ReturnCodeConstants__fini(rc_common_msgs__msg__ReturnCodeConstants * msg)
{
  if (!msg) {
    return;
  }
  // structure_needs_at_least_one_member
}

bool
rc_common_msgs__msg__ReturnCodeConstants__are_equal(const rc_common_msgs__msg__ReturnCodeConstants * lhs, const rc_common_msgs__msg__ReturnCodeConstants * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // structure_needs_at_least_one_member
  if (lhs->structure_needs_at_least_one_member != rhs->structure_needs_at_least_one_member) {
    return false;
  }
  return true;
}

bool
rc_common_msgs__msg__ReturnCodeConstants__copy(
  const rc_common_msgs__msg__ReturnCodeConstants * input,
  rc_common_msgs__msg__ReturnCodeConstants * output)
{
  if (!input || !output) {
    return false;
  }
  // structure_needs_at_least_one_member
  output->structure_needs_at_least_one_member = input->structure_needs_at_least_one_member;
  return true;
}

rc_common_msgs__msg__ReturnCodeConstants *
rc_common_msgs__msg__ReturnCodeConstants__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_common_msgs__msg__ReturnCodeConstants * msg = (rc_common_msgs__msg__ReturnCodeConstants *)allocator.allocate(sizeof(rc_common_msgs__msg__ReturnCodeConstants), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rc_common_msgs__msg__ReturnCodeConstants));
  bool success = rc_common_msgs__msg__ReturnCodeConstants__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rc_common_msgs__msg__ReturnCodeConstants__destroy(rc_common_msgs__msg__ReturnCodeConstants * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rc_common_msgs__msg__ReturnCodeConstants__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rc_common_msgs__msg__ReturnCodeConstants__Sequence__init(rc_common_msgs__msg__ReturnCodeConstants__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_common_msgs__msg__ReturnCodeConstants * data = NULL;

  if (size) {
    data = (rc_common_msgs__msg__ReturnCodeConstants *)allocator.zero_allocate(size, sizeof(rc_common_msgs__msg__ReturnCodeConstants), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rc_common_msgs__msg__ReturnCodeConstants__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rc_common_msgs__msg__ReturnCodeConstants__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rc_common_msgs__msg__ReturnCodeConstants__Sequence__fini(rc_common_msgs__msg__ReturnCodeConstants__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rc_common_msgs__msg__ReturnCodeConstants__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rc_common_msgs__msg__ReturnCodeConstants__Sequence *
rc_common_msgs__msg__ReturnCodeConstants__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_common_msgs__msg__ReturnCodeConstants__Sequence * array = (rc_common_msgs__msg__ReturnCodeConstants__Sequence *)allocator.allocate(sizeof(rc_common_msgs__msg__ReturnCodeConstants__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rc_common_msgs__msg__ReturnCodeConstants__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rc_common_msgs__msg__ReturnCodeConstants__Sequence__destroy(rc_common_msgs__msg__ReturnCodeConstants__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rc_common_msgs__msg__ReturnCodeConstants__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rc_common_msgs__msg__ReturnCodeConstants__Sequence__are_equal(const rc_common_msgs__msg__ReturnCodeConstants__Sequence * lhs, const rc_common_msgs__msg__ReturnCodeConstants__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rc_common_msgs__msg__ReturnCodeConstants__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rc_common_msgs__msg__ReturnCodeConstants__Sequence__copy(
  const rc_common_msgs__msg__ReturnCodeConstants__Sequence * input,
  rc_common_msgs__msg__ReturnCodeConstants__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rc_common_msgs__msg__ReturnCodeConstants);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rc_common_msgs__msg__ReturnCodeConstants * data =
      (rc_common_msgs__msg__ReturnCodeConstants *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rc_common_msgs__msg__ReturnCodeConstants__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rc_common_msgs__msg__ReturnCodeConstants__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rc_common_msgs__msg__ReturnCodeConstants__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
